﻿using UnityEngine;
using System.Collections;

public class Fader : MonoBehaviour
{
	public static void StartFade(GameObject target, float duration)
	{
		var self = target.AddComponent<Fader>();
		self.m_Duration = duration;

		// remove any colliders from target
		Destroy (target.GetComponent<Collider2D>());
	}

	float m_Duration;

	void Start ()
	{
		StartCoroutine(FadeLogic());
	}
	
	IEnumerator FadeLogic()
	{
		// remove trigger
		var sr = GetComponent<SpriteRenderer>();
		var col = sr.color;
		yield return 0;
		while (col.a > 0.0f)
		{
			col.a -= Time.deltaTime / m_Duration;
			sr.color = col;
			yield return 0;
		}

		// destroy once faded out
		Destroy (gameObject);
	}
}
