﻿using UnityEngine;
using System.Collections;

public class HealthPickup : MonoBehaviour
{
	public float health = 5.0f;
	public float fadeTime = 0.5f;
	public AudioClip sound;

	public void OnTriggerEnter2D(Collider2D other)
	{
		var player = PlayerController.instance;
		if (!player)
			return;
		if (player.transform != other.transform)
			return;

		if (player.AddHealth(health))
		{
			AudioSource.PlayClipAtPoint(sound, transform.position);
			Fader.StartFade(gameObject, fadeTime);
		}
	}
}
