﻿using UnityEngine;
using System.Collections;
using System.Text;


// Adapted from http://stackoverflow.com/a/1891422

public class WordGenerator
{
	const string kVowels = "aeiou";
	const string kConsonants = "bcdfghjklmnpqrstvwxyz";
	// http://www.sttmedia.com/syllablefrequency-english
	static string[] kCommon = new[]{"ver", "was", "hat", "not", "for", "thi", "tha", "ent", "ith", "ion", "wit", "eve", "oul", "uld", "ing"};

	static void GetVowel(StringBuilder sb) { sb.Append (kVowels[Random.Range(0,kVowels.Length)]); }
	static void GetConsonant(StringBuilder sb) { sb.Append (kConsonants[Random.Range(0,kConsonants.Length)]); }
	static void GetCV(StringBuilder sb) { GetConsonant(sb); GetVowel(sb); }
	static void GetCVC(StringBuilder sb) { GetConsonant(sb); GetVowel(sb); GetConsonant(sb); }
	static void GetCommonSyllable(StringBuilder sb) { sb.Append (kCommon[Random.Range (0,kCommon.Length)]); }

	static void GetSyllable(StringBuilder sb)
	{
		var r = Random.Range (0,4);
		switch(r) {
		case 0: GetVowel(sb); break;
		case 1: GetCV(sb); break;
		case 2: GetCVC(sb); break;
		case 3:
			GetCommonSyllable(sb); break;
		}
	}

	static public string GetWord(int minLen = 2, int maxLen = 4)
	{
		var r = Random.Range (2,4+1);
		var sb = new StringBuilder(16);
		for (var i = 0; i < r; ++i)
			GetSyllable(sb);
		return sb.ToString();
	}
}
